# Tracker Formats Documentation
Some of the documentation links were obtained from: 
* https://github.com/dbrookman/trackrip 
* https://github.com/a740g/QB64-MOD-Player

Feel free to check out these projects. 

I have also written up some documentation. But they're used internally so not everything is completely documented. 

My docs shouldn't contain anything you won't find in these linked resources.

## Resources
### IT
* [General IT info](https://wiki.openmpt.org/Development:_Formats/IT)
* [(ARCHIVE) ITTECH.TXT](https://web.archive.org/web/20220610182703/https://github.com/schismtracker/schismtracker/wiki/ITTECH.TXT)
* [(ARCHIVE 2) ITTECH.TXT](https://ia600506.us.archive.org/view_archive.php?archive=/4/items/msdos_it214c_shareware/it214c.zip&file=ITTECH.TXT)
* [IT COMPRESSION DOCS](https://wiki.multimedia.cx/index.php/Impulse_Tracker#IT214_sample_compression)
* [IT SAMPLE DECOMPRESSION ALGORITHM 1 ( C )](https://github.com/nicolasgramlich/AndEngineMODPlayerExtension/blob/master/jni/loaders/itsex.c)
* [IT SAMPLE DECOMPRESSION ALGORITHM 2 ( C )](https://github.com/schismtracker/schismtracker/blob/master/fmt/compression.c)
* [IT SAMPLE DECOMPRESSION ALGORITHM 3 ( My RUST implementation )](https://github.com/B0ney/tracker_dump/blob/main/src/it/compression.rs)
* [(ARCHIVE) Identify MMCMP-compression](https://web.archive.org/web/20220715082920/https://itsoundswrong.blogspot.com/2011/07/magic-module-complicator-my-progress-so.html)

### S3M
* https://moddingwiki.shikadi.net/wiki/S3M_Format
* https://wiki.openmpt.org/Development:_Formats/S3M
* [(ARCHIVE) FS3MDOC.TXT](https://raw.githubusercontent.com/a740g/QB64-MOD-Player/main/docs/FS3MDOC.TXT)

### MOD
* [(ARCHIVE) https://www.aes.id.au/modformat.html](https://web.archive.org/web/20220628212406/https://www.aes.id.au/modformat.html)
* https://wiki.multimedia.cx/index.php/Protracker_Module
* [XPK-compressed](https://modarchive.org/forums/index.php?topic=4545.0)
* [QB64-MOD-Player Docs](https://github.com/a740g/QB64-MOD-Player/tree/main/docs)


### XM
* [XM-FORM](https://github.com/milkytracker/MilkyTracker/blob/master/resources/reference/xm-form.txt) (most up to date)
* [Pseudocode for converting the delta-coded data to normal data,](https://github.com/milkytracker/MilkyTracker/blob/master/resources/reference/xm-form.txt#L303-L316=)
* [Obtain sampling frequency](https://github.com/milkytracker/MilkyTracker/blob/master/resources/reference/xm-form.txt#L639-L640=)
* [(ARCHIVE) Additional XM notes](https://web.archive.org/web/20220715083138/https://itsoundswrong.blogspot.com/2012/01/important-xm-notes.html)

### UMX
* [(ARCHIVE) wiki.beyondunreal.com/Legacy:Package_File_Format](https://web.archive.org/web/20220324122909/https://wiki.beyondunreal.com/Legacy:Package_File_Format)
* [(ARCHIVE) bunnytrack.net/ut-package-format/](https://web.archive.org/web/20220319154052/https://bunnytrack.net/ut-package-format/)


## MISC
### OpenMPT Resources
* https://resources.openmpt.org/
### WAV File
[(ARCHIVE) www.ringthis.com/dev/wave_format.htm](https://web.archive.org/web/20220517120900/http://www.ringthis.com/dev/wave_format.htm)
## Websites for obtaining tracker modules
* https://modarchive.org/
* (Torrents) http://tracker.modarchive.org/
* (Open Directory) https://modland.com/pub/modules/ 
* (Open Directory) http://mod.zayda.net/mods/
* (Open Directory) https://resources.openmpt.org/player_tests/

## Tracker Software/Player
* SchismTracker: https://github.com/schismtracker/schismtracker
* FastTracker2-clone: https://github.com/8bitbubsy/ft2-clone
* (Open Directory) http://rigelseven.com/tracker_museum/
* https://github.com/a740g/QB64-MOD-Player (Windows only, but works flawlessly with WINE)

**Please be mindful if you're obtaining files from open directories.**